import { all } from "../../service-type-resolvers/all.js";
import { single } from "../../service-type-resolvers/single.js";
import { isServiceTypeResolver } from "../../service-type-resolvers/BaseServiceTypeResolver.js";
export function mapDependenciesCompatible(dependencies) {
    return dependencies.map((dependency) => {
        if (isServiceTypeResolver(dependency)) {
            return dependency;
        }
        if (Array.isArray(dependency)) {
            return all(dependency[0]);
        }
        return single(dependency);
    });
}
//# sourceMappingURL=mapDependenciesCompatible.js.map