import type { IServiceCollection, IServiceConstructor, IServiceDescriptor, IServiceFactory, IServiceImplementationResolver, SingleServiceImplementation, SingleServiceType } from "../types/index.js";
export declare class ServiceCollection implements IServiceCollection {
    protected readonly collection: Map<any, IServiceDescriptor<unknown>[]>;
    constructor(collection?: ServiceCollection);
    [Symbol.iterator](): Iterator<IServiceDescriptor<unknown>, any, undefined>;
    getDescriptors<T>(service: SingleServiceType<T>): IServiceDescriptor<T>[];
    getDescriptor<T>(service: SingleServiceType<T>): IServiceDescriptor<T>;
    addScoped<T>(service: SingleServiceImplementation<T>): this;
    addScoped<T>(service: SingleServiceType<T>, factory: IServiceFactory<T>): this;
    addScoped<T>(service: SingleServiceType<T>, constructor: IServiceConstructor<T>): this;
    addScoped<T, TResolver extends IServiceImplementationResolver<T | SingleServiceImplementation<T>>>(service: SingleServiceType<T>, resolver: TResolver): this;
    addTransient<T>(service: SingleServiceImplementation<T>): this;
    addTransient<T>(service: SingleServiceType<T>, factory: IServiceFactory<T>): this;
    addTransient<T>(service: SingleServiceType<T>, constructor: IServiceConstructor<T>): this;
    addTransient<T, TResolver extends IServiceImplementationResolver<T | SingleServiceImplementation<T>>>(service: SingleServiceType<T>, resolver: TResolver): this;
    addSingleton<T>(service: SingleServiceImplementation<T>): this;
    addSingleton<T>(service: SingleServiceType<T>, implementation: T): this;
    addSingleton<T>(service: SingleServiceType<T>, factory: IServiceFactory<T>): this;
    addSingleton<T>(service: SingleServiceType<T>, constructor: IServiceConstructor<T>): this;
    addSingleton<T, TResolver extends IServiceImplementationResolver<T | SingleServiceImplementation<T>>>(service: SingleServiceType<T>, resolver: TResolver): this;
    protected copy(): Iterable<[any, IServiceDescriptor<unknown>[]]>;
    private addService;
}
//# sourceMappingURL=ServiceCollection.d.ts.map