import { mapDependenciesCompatible, } from "../compatible-layer/zero/mapDependenciesCompatible.js";
import { ServiceRegistry } from "./ServiceRegistry.js";
import { all } from "../service-type-resolvers/all.js";
import { optional } from "../service-type-resolvers/optional.js";
import { single } from "../service-type-resolvers/single.js";
function injectable(dependencies = () => []) {
    return (target, context) => {
        let name = target.name;
        // context is undefined for legacy decorators (stage 2)
        if (context !== undefined) {
            name = context.name ?? name;
        }
        Object.defineProperty(target, "name", {
            value: name,
            writable: false,
        });
        ServiceRegistry.register(target, {
            name,
            dependencies: mapDependenciesCompatible(dependencies({ all, optional, single })),
        });
        return target;
    };
}
export { injectable };
//# sourceMappingURL=injectable.js.map