export async function resolveGeneratorAsync(iterator) {
    let result;
    while (!(result = iterator.next()).done) {
        try {
            await result.value;
        }
        catch (err) {
            result = iterator.throw(err);
            if (result.done) {
                break;
            }
        }
    }
    return result.value;
}
//# sourceMappingURL=resolveGeneratorAsync.js.map