import { getNameOfServiceType } from "../helpers/getNameOfServiceType.js";
import { BaseServiceImplementationResolver, isServiceImplementationResolver, } from "./BaseServiceImplementationResolver.js";
export class ValueServiceImplementationResolver extends BaseServiceImplementationResolver {
    implementation;
    get name() {
        return getNameOfServiceType(this.implementation);
    }
    constructor(implementation) {
        super();
        this.implementation = implementation;
    }
    *resolve(internalGetService, descriptor, requestedBy, mode) {
        let implementation = this.implementation;
        if (isServiceImplementationResolver(implementation)) {
            implementation = (yield* implementation.resolve(internalGetService, descriptor, requestedBy, mode));
        }
        return () => implementation;
    }
}
//# sourceMappingURL=ValueServiceImplementationResolver.js.map