import type { ServiceType, IServiceDescriptor, IResolverServiceType, SingleServiceType, IServiceDescriptorResolver, IServiceCollection, IServiceInstancesStore } from "../types/index.js";
export declare abstract class BaseServiceTypeResolver<In, Out> implements IResolverServiceType<In, Out> {
    readonly next: ServiceType<In>;
    get name(): string;
    get service(): SingleServiceType<In>;
    constructor(next: ServiceType<In>);
    abstract resolve(collection: IServiceCollection, instancesStore: IServiceInstancesStore, resolveServiceImplementation: IServiceDescriptorResolver, requestedBy: Set<IServiceDescriptor<any>>, mode: "sync" | "async", descriptor?: IServiceDescriptor<In>): Generator<Promise<unknown>, Out, unknown>;
}
export declare function isServiceTypeResolver<In, Out>(value: unknown): value is IResolverServiceType<In, Out>;
//# sourceMappingURL=BaseServiceTypeResolver.d.ts.map