import { BaseServiceTypeResolver, isServiceTypeResolver, } from "./BaseServiceTypeResolver.js";
export class ListServiceTypeResolver extends BaseServiceTypeResolver {
    constructor(next) {
        super(next);
    }
    *resolve(collection, instancesStore, resolveServiceImplementation, requestedBy, mode) {
        const descriptors = collection.getDescriptors(this.service);
        const services = [];
        let next = this.next;
        for (const descriptor of descriptors) {
            if (isServiceTypeResolver(next)) {
                services.push(yield* next.resolve(collection, instancesStore, resolveServiceImplementation, requestedBy, mode, descriptor));
            }
            else {
                services.push(yield* resolveServiceImplementation(descriptor, requestedBy, mode));
            }
        }
        return services;
    }
}
//# sourceMappingURL=ListServiceTypeResolver.js.map