import type { ServiceType, IServiceDescriptor, IServiceDescriptorResolver, IServiceCollection, IResolverServiceType, IServiceInstancesStore } from "../types/index.js";
import { BaseServiceTypeResolver } from "./BaseServiceTypeResolver.js";
export interface IOptionalService<T> {
    resolve(): T;
    resolveAsync(): Promise<T>;
}
export declare class OptionalServiceTypeResolver<T> extends BaseServiceTypeResolver<T, IOptionalService<T>> {
    constructor(next: ServiceType<T>);
    resolve(collection: IServiceCollection, instancesStore: IServiceInstancesStore, resolveServiceImplementation: IServiceDescriptorResolver, requestedBy: Set<IServiceDescriptor<any>>, mode: "sync" | "async", descriptor?: IServiceDescriptor<T>): Generator<Promise<unknown>, IOptionalService<T>, unknown>;
}
export declare function isOptionalServiceTypeResolver<T>(value: IResolverServiceType<T, any>): value is IResolverServiceType<T, IOptionalService<T>>;
//# sourceMappingURL=OptionalServiceTypeResolver.d.ts.map