import { BaseServiceTypeResolver, isServiceTypeResolver, } from "./BaseServiceTypeResolver.js";
export class SingleServiceTypeResolver extends BaseServiceTypeResolver {
    constructor(next) {
        super(next);
    }
    *resolve(collection, instancesStore, resolveServiceImplementation, requestedBy, mode, descriptor) {
        let next = this.next;
        if (isServiceTypeResolver(next)) {
            return yield* next.resolve(collection, instancesStore, resolveServiceImplementation, requestedBy, mode, descriptor);
        }
        return yield* resolveServiceImplementation(descriptor ?? collection.getDescriptor(next), requestedBy, mode);
    }
}
//# sourceMappingURL=SingleServiceTypeResolver.js.map